USING SFDC.*.
USING System.Net.*.
USING System.Text.*.  
USING Progress.Lang.*.
USING Progress.Json.ObjectModel.*.
USING System.IO.*.
  
DEFINE VARIABLE cSFDCLib     AS SFDCLib           NO-UNDO. 
DEFINE VARIABLE oWebClient   AS WebClient         NO-UNDO.
DEFINE VARIABLE jsonResponse AS LONGCHAR          NO-UNDO.
DEFINE VARIABLE vURL         AS CHARACTER         NO-UNDO.
DEFINE VARIABLE strJSON      AS LONGCHAR          NO-UNDO.
DEFINE VARIABLE oParse       AS ObjectModelParser NO-UNDO.
DEFINE VARIABLE oJSON        AS JsonObject        NO-UNDO.
DEFINE VARIABLE vSuccess     AS CHARACTER         NO-UNDO.
DEFINE VARIABLE vId          AS CHARACTER         NO-UNDO.
     
cSFDCLib = NEW SFDC.SFDCLib().
cSFDCLib:loginToSFDCREST().

/* you would build this from the fields in the TT and deal with data-type formatting */
strJson = 
  '~{     
        "Name" : "TestAccount", 
        "AccountNumber" : "1234567",
        "BillingState" : "MA" 
      ~} '.                              
 
vURL = cSFDCLib:instanceURL + "/services/data/v24.0/sobjects/Account" .
oWebClient = NEW WebClient().
oWebClient:Encoding = Encoding:UTF8.
oWebClient:Headers:Set("Content-Type", "application/json").
oWebClient:Headers:Set("Authorization", "Bearer " + cSFDCLib:accessToken).
jsonResponse = oWebClient:UploadString(vURL, "Post", strJSON).
 
Util.DemoUtils:BigMessage(jsonResponse).

/* Get the returned ID from the JSON if the insert was successfull */      
oParse = NEW Progress.Json.ObjectModel.ObjectModelParser().
oJSON = CAST (oParse:Parse(jsonResponse),JsonObject).
    
vId = oJSON:GetJsonText("id").
Util.DemoUtils:BigMessage(vId).

 
/*--------------------------------------------- */

CATCH e AS Progress.Lang.Error:
  DEFINE VARIABLE oWebException AS System.Net.WebException NO-UNDO.
  DEFINE VARIABLE Response      AS HttpWebResponse         NO-UNDO.
  DEFINE VARIABLE SR            AS StreamReader            NO-UNDO.
  DEFINE VARIABLE lcResponse    AS LONGCHAR                NO-UNDO.
  
  /* useful messages returned by the DotNet WebClient object are burried a little */
  IF  TYPE-OF(e,System.Net.WebException) THEN 
  DO:
    oWebException = CAST (e, System.Net.WebException). 
    Response = CAST(oWebException:Response, HttpWebResponse).
    SR = NEW StreamReader(Response:GetResponseStream(),System.Text.Encoding:UTF8).
    lcResponse = SR:ReadToEnd().
    Util.DemoUtils:BigMessage (lcResponse).
  END.
  ELSE 
    Util.DemoUtils:BigMessage (e:GetMessage (1)).
END. 