 
/*------------------------------------------------------------------------
   File        : DemoUtils
   Purpose     : 
   Syntax      : 
   Description : 
   Author(s)   : Gerry.Winning gwinning@gmail.com
   Created     : Fri May 09 14:22:45 EDT 2014
   Notes       : 
 ----------------------------------------------------------------------*/

USING Progress.Lang.*.
USING Util.*.

CLASS Util.DemoUtils: 

  DEFINE PUBLIC STATIC PROPERTY SupressMessages AS LOGICAL NO-UNDO 
    GET.
    SET. 

  /*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/

  METHOD PUBLIC STATIC VOID BigMessage( pMessage AS LONGCHAR  ):
    DEFINE VARIABLE myMessage AS ShowMessage NO-UNDO .
    
    IF SupressMessages THEN RETURN.
    myMessage = NEW ShowMessage().
    myMessage:txtMessage:value  = REPLACE (pMessage, CHR (10), CHR (13) + CHR (10)).    
    myMessage:ShowModalDialog().
    DELETE OBJECT myMessage NO-ERROR.    
    RETURN.
  END METHOD.
  
  METHOD PUBLIC STATIC VOID BigXMLMessage (pFile AS CHARACTER ):
    DEFINE VARIABLE lcFileContents AS LONGCHAR NO-UNDO.
    COPY-LOB FILE pfile TO lcFileContents. 
    BigMessage (FormatXML(lcFileContents)). 
  END METHOD. 
  
  METHOD PUBLIC STATIC VOID BigXMLMessage (pXML AS LONGCHAR):
    BigMessage (FormatXML(pXML)). 
  END METHOD. 
 

  METHOD PUBLIC STATIC LONGCHAR FormatXml( pXml AS LONGCHAR ):
    DEFINE VARIABLE xdoc  AS System.Xml.Linq.XDocument.   
    DEFINE VARIABLE vLong AS LONGCHAR                  NO-UNDO.

    /* the "STRING()" is to work around a progress bug with UTF-Data and the longchar */
    xdoc = System.Xml.Linq.XDocument:Parse(STRING (pXml)) .
    vLong = xdoc:ToString().
    
    RETURN vLong.
  END METHOD.

END CLASS.